
// Gives us access to all functions in the 'system' namespace
using System;

class UsingLoopsAndMethods {

	// This program demonstrates the 4 types of loops
	// and also shows the 4 different ways methods can be called
	
	// menu
	public void ShowMenu(){
	
		Console.Write("(1) Do loop\n");
		Console.Write("(2) While loop\n");
		Console.Write("(3) For loop\n");
		Console.Write("(4) For-Each loop\n");
	}
	
	// constructor
	public UsingLoopsAndMethods(){
		
	}
	
	
	// Method to demonstrate the FOR Loop
	// This Method accepts a VALUE PARAMETER
	// Method counts from one all the way to 'a_value' which is passed
	// in as the parameter
	public void ForLoop(int a_value){
	
	int counter;
		Console.Write("The For Loop will now count up to {0}\n", a_value);
		for (counter=1; counter<=a_value; counter++) {
			Console.Write("{0}\n", counter);
		}
	}
	
	// Method to demonstrate the FOR EACH Loop
	// This Method accepts a PARAMS PARAMETER
	// Method counts through the comma seperated string
	public void ForEach(params string[] words){
	
		Console.Write("The For-Each Loop will now count through the comma-separated strings passed in\n");
		foreach (string word in words) {
			Console.Write("{0}\n", word);
		}
	}
	
	// Method to demonstrate the DO Loop
	// This Method accepts an OUT PARAMETER
	// Method asks the user to type either 'quit' or 'exit'.
	// If the user doesn't enter either of those words,
	// it will ask again and keep doing so until
	// 'quit' or 'exit' is entered
	
	public void DoLoop(out string unassignedReference){
	
		string userInput = "";
		
		do {
		Console.Write("\nPlease enter either 'quit' or 'exit' in lower case:");
		
		userInput = Console.ReadLine();
		} while (userInput != "quit" && userInput != "exit");
		
		// this point in the program is only ever reached if the
		// criteria for the do-loop is met
		
		unassignedReference = userInput;
	}
	
	// Method to demonstrate the WHILE Loop
	// This Method accepts a REF PARAMETER
	// Method counts from 1 to 5, then changes the
	// string passed in

	public void WhileLoop(ref string stringToChange){
	
		int someInt=1;
		
		while (someInt <= 5) {
			Console.Write("\nsomeInt is: {0}", someInt);
			someInt++;
		}
		
			// at this point someInt is 6, because if it was 5 or less
			// we would still be in the above WHILE loop 
		stringToChange = someInt.ToString();
	}
	
	
	
	public static int Main(){

			// create an instance of the 'UsingLoopsAndMethods' class
			UsingLoopsAndMethods programInstance = new UsingLoopsAndMethods();
	
			// ShowMenu is not a static method, which means it
			// can only be called in an INSTANCE of the
			// UsingLoopsAndMethods class.
			
			getChoice: // label
			
			programInstance.ShowMenu(); 
	
			int yourMenuChoice;
	
			Console.Write("\n\nPlease enter a menu choice: "); 
			yourMenuChoice = Int32.Parse(Console.ReadLine()); 
														  			
		
			switch(yourMenuChoice) {
				case 1:
						string some_string; // unassigned reference
						programInstance.DoLoop(out some_string);
						Console.Write("\nUser entered '{0}' in the Do Loop:", some_string);
						
						break;
				case 2:
						string stringToChange = "initial value!";
						Console.Write("\nThe value of stringToChange before entering the function is: {0}",  stringToChange);
						programInstance.WhileLoop(ref stringToChange);
						Console.Write("\nThe Value of stringToChange after the function is: {0}",  stringToChange);
						break;
				case 3:
						programInstance.ForLoop(4);
						break;
				case 4:
						programInstance.ForEach("word1", "word2", "word3", "word4");
						break;
				default:
						Console.Write("INVALID ENTRY - TRY AGAIN");
						goto getChoice;
			}
			
			return 1; // any int value will do
 
	}
}
